/****** Object:  Table [dbo].[TbEstoqueCheckList]    Script Date: 29/12/2020 23:53:27 ******/
IF Not (EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES 
                WHERE TABLE_NAME = 'TbEstoqueCheckList')) BEGIN
	SET ANSI_NULLS ON

	SET QUOTED_IDENTIFIER ON

	CREATE TABLE [dbo].[TbEstoqueCheckList](
		[IdCheckList] [int] IDENTITY(1,1) NOT NULL,
		[Data] [date] NULL,
		[Tipo] [char](1) NULL,
		[CdUsuario] [int] NULL,
		[Status] [int] NULL,
	 CONSTRAINT [PK_TbEstoqueCheckList_1] PRIMARY KEY CLUSTERED 
	(
		[IdCheckList] ASC
	)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
	) ON [PRIMARY]
End;

IF Not (EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES 
                WHERE TABLE_NAME = '[TbEstoqueCheckListProduto]')) BEGIN
/****** Object:  Table [dbo].[TbEstoqueCheckListProduto]    Script Date: 29/12/2020 23:54:00 ******/
	SET ANSI_NULLS ON

	SET QUOTED_IDENTIFIER ON

	CREATE TABLE [dbo].[TbEstoqueCheckListProduto](
		[idchecklistitem] [int] IDENTITY(1,1) NOT NULL,
		[IdCheckList] [int] NOT NULL,
		[cdlote] [int] NULL,
		[cdendereco] [int] NULL,
		[qtdestoque] [int] NULL,
		[qtdcontagem] [int] NULL,
		[CdUsuario] [int] NULL,
		[DataHora] [datetime] NULL,
	 CONSTRAINT [PK_TbEstoqueCheckListProduto] PRIMARY KEY CLUSTERED 
	(
		[idchecklistitem] ASC
	)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
	) ON [PRIMARY]

	ALTER TABLE [dbo].[TbEstoqueCheckListProduto]  WITH CHECK ADD  CONSTRAINT [FK_TbEstoqueCheckListProduto_TbEstoqueCheckList] FOREIGN KEY([IdCheckList])
	REFERENCES [dbo].[TbEstoqueCheckList] ([IdCheckList])
	ON UPDATE CASCADE
	ON DELETE CASCADE

	ALTER TABLE [dbo].[TbEstoqueCheckListProduto] CHECK CONSTRAINT [FK_TbEstoqueCheckListProduto_TbEstoqueCheckList]
End;

--TbEstoqueReserva
--Apagar a Constraint Primary Key
ALTER TABLE TbEstoqueReserva DROP CONSTRAINT pkEstoqueReserva;
Alter Table TbEstoqueReserva Drop Column CdReserva

--Criar a Primary Key
Alter Table TbEstoqueReserva
   Add [cdReserva] [int] IDENTITY(1,1) NOT NULL,
 CONSTRAINT [pkEstoqueReserva] PRIMARY KEY CLUSTERED 
(
	[cdReserva] ASC)


--TbEstoqueReservaHistorico
--Apagar a Constraint Primary Key
ALTER TABLE TbEstoqueReservaHistorico DROP CONSTRAINT pkEstoqueReservaHistorico;
Alter Table TbEstoqueReservaHistorico Drop Column CdReservaHistorico

--Criar a Primary Key
Alter Table TbEstoqueReservaHistorico
   Add [cdReservaHistorico] [int] IDENTITY(1,1) NOT NULL,
 CONSTRAINT [pkEstoqueReservaHistorico] PRIMARY KEY CLUSTERED 
(
	[cdReservaHistorico] ASC)


--TbHistorico
--Apagar a Constraint Primary Key
ALTER TABLE TbHistorico DROP CONSTRAINT pkHistorico;
Alter Table TbHistorico Drop Column CdHistorico

--Criar a Primary Key
Alter Table TbHistorico
   Add [cdHistorico] [int] IDENTITY(1,1) NOT NULL,
 CONSTRAINT [pkHistorico] PRIMARY KEY CLUSTERED 
(
	[cdHistorico] ASC)
	
	
/****** Object:  Trigger [dbo].[tgEstoqueReservaHistorico]    Script Date: 11/01/2021 12:01:05 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-----------------------------------------------------------------------------------------------------------------------------
IF(EXISTS(SELECT * FROM  sys.triggers WHERE NAME = 'tgEstoqueReservaHistorico'))
    BEGIN
        DROP TRIGGER [dbo].[tgEstoqueReservaHistorico];
    END;
GO

/****** Object:  Trigger [dbo].[tgEstoqueReservaHistorico]    Script Date: 11/01/2021 13:48:15 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-----------------------------------------------------------------------------------------------------------------------------

CREATE TRIGGER [dbo].[tgEstoqueReservaHistorico] ON [dbo].[tbEstoqueReserva]
AFTER INSERT, DELETE, UPDATE AS 
BEGIN
	SET NOCOUNT ON;
	if exists (select top 1 cdReserva from deleted)
		begin
			update
				hst
			set
				hst.dtFim = GETDATE()
			from
				tbEstoqueReservaHistorico as hst
				inner join deleted as d on
					hst.cdEstoqueTipo               = d.cdEstoqueTipo
					and coalesce(hst.cdEndereco, 0) = coalesce(d.cdEndereco, 0)
					and hst.cdLote                  = d.cdLote
					and hst.cdReservaMotivo         = d.cdReservaMotivo
					and hst.cdRegistro              = d.cdRegistro
			where
				hst.dtFim is null
		end;
	if exists (select top 1 cdReserva from inserted)
		begin
			declare @cdReservaHistorico int = (select coalesce(MAX(cdReservaHistorico), 0) from tbEstoqueReservaHistorico);
			insert into tbEstoqueReservaHistorico (
				--cdReservaHistorico,
				 cdUsuario
				, cdEstoqueTipo
				, cdEndereco
				, cdLote
				, cdReservaMotivo
				, cdRegistro
				, qtReservada
				, dtInicio
			)
			select
				--ROW_NUMBER() over (order by cdLote) + @cdReservaHistorico,
				 cdUsuario
				, cdEstoqueTipo
				, cdEndereco
				, cdLote
				, cdReservaMotivo
				, cdRegistro
				, qtReservada
				, GETDATE()
			from
				inserted
		end
END
GO

ALTER TABLE [dbo].[tbEstoqueReserva] ENABLE TRIGGER [tgEstoqueReservaHistorico]
GO
	

